////////  Programa Carniceria  //////////////////////////////////////////////////////////////////////////////////

#include "hmg.ch"

Declare Window Main

Function main_button_ventas_action

	Use CAMBIO New
		Go Bottom
		
			dFecha := CAMBIO->FECHA
			
		If dFecha == Date ()
			MsgStop ("La caja ya ha sido cerrada el dia de hoy " + DtoC (dFecha) + Chr (13) + Chr (10) + ;
					"Ya no podrá volver a cerrarla o realizar ventas !!!" , "ATENCION !!!")
			Use
			Return Nil
		EndIf
		
	Use

	Load Window Ventas
	
		DoMethod (Ventas.StatusBar.Item (2) := pcUsuario)	
		
	Ventas. Center
	Ventas. Activate

Return Nil
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Function Ventas_text_codigo_leido_onenter

	nCant = pnCantidad
	SetProperty ("Ventas" , "Label_Cantidad" , "Value" , Str (nCant))
	
	cCodigoLeido := GetProperty ("Ventas" , "Text_Codigo_Leido" , "Value")			// Salida del lector de codigos

	Do Case

		Case AT ("*",cCodigoLeido) = 1
			Limpia_Gets ()
			Return Nil																	// Cancelo la lectura

		Case AT ("*",cCodigoLeido) = 2
			nCant = Val (SubStr (cCodigoLeido,1,1))
			pnCantidad = nCant
			SetProperty ("Ventas" , "Text_Codigo_Leido" , "Value" , "")
			SetProperty ("Ventas" , "Label_Cantidad" , "Value" , Str (nCant))
			Return Nil

		Case AT ("*",cCodigoLeido) = 3
			nCant = Val (SubStr (cCodigoLeido,1,2))
			pnCantidad = nCant
			SetProperty ("Ventas" , "Text_Codigo_Leido" , "Value" , "")
			SetProperty ("Ventas" , "Label_Cantidad" , "Value" , Str (nCant))
			Return Nil

		Case AT ("*",cCodigoLeido) = 4
			nCant = Val (SubStr (cCodigoLeido,1,3))
			pnCantidad = nCant
			SetProperty ("Ventas" , "Text_Codigo_Leido" , "Value" , "")
			SetProperty ("Ventas" , "Label_Cantidad" , "Value" , Str (nCant))
			Return Nil

		Case AT ("*",cCodigoLeido) = 5
			nCant = Val (SubStr (cCodigoLeido,1,4))
			pnCantidad = nCant
			SetProperty ("Ventas" , "Text_Codigo_Leido" , "Value" , "")
			SetProperty ("Ventas" , "Label_Cantidad" , "Value" , Str (nCant))
			Return Nil
			
		// OtherWise
			// nCant = 1
			// SetProperty ("Ventas" , "Label_Cantidad" , "Value" , "1")
			// SetProperty ("Ventas" , "Text_Codigo_Leido" , "Value" , "")
	EndCase

	If Empty (cCodigoLeido)
		Limpia_Gets ()
		Return Nil
	EndIf
	

	DO Case
		Case Len (cCodigoLeido) = 8
			If SubStr (cCodigoLeido,1,3) = "779"
				DoMethod (Ventas.StatusBar.Item (4) := "EAN-8  779 Argentina")
				FLAG = 0
			Else
				DoMethod (Ventas.StatusBar.Item (4) := "EAN-8  Desconocido")
				FLAG = 0
			EndIf	
		Case Len (cCodigoLeido) = 14
			If SubStr (cCodigoLeido,2,3) = "779"
				DoMethod (Ventas.StatusBar.Item (4) := "DUN-14  779 Argentina")
				FLAG = 0
			Else
				DoMethod (Ventas.StatusBar.Item (4) := "DUN-14  Desconocido")
				FLAG = 0
			EndIf	
		Case Len (cCodigoLeido) = 13
			DO Case
				Case SubStr (cCodigoLeido,1,3) = "779"
					DoMethod (Ventas.StatusBar.Item (4) := "EAN-13  779 Argentina")
					FLAG = 0
				Case SubStr (cCodigoLeido,1,3) = "789"
					DoMethod (Ventas.StatusBar.Item (4) := "EAN-13  789 Brasil")
					FLAG = 0
				Case SubStr (cCodigoLeido,1,2) = "20"
					DoMethod (Ventas.StatusBar.Item (4) := "EAN-13  20 Venta Por Peso")
					FLAG = 1
				Case SubStr (cCodigoLeido,1,2) = "21"
					DoMethod (Ventas.StatusBar.Item (4) := "EAN-13  21 Venta Por Unidad")
					FLAG = 1
				Case SubStr (cCodigoLeido,1,2) = "22"
					DoMethod (Ventas.StatusBar.Item (4) := "EAN-13  22 Suma De Articulos")
					FLAG = 1
			EndCase
		OtherWise
			DoMethod (Ventas.StatusBar.Item (4) := "Desconocido")
			FLAG = 0
	EndCase
		
	DO Case
		Case FLAG = 0														// Cero es que leyo un articulo Externo

				SetProperty ("Ventas" , "Button_Leer_Externos" , "Picture" , "Verde32")
				SetProperty ("Ventas" , "Button_Leer_Internos" , "Picture" , "Clear32")

				DbSelectArea ( "EXTERNOS" )		
					DbSeek (AllTrim (cCodigoLeido), .F.)
			
						If Found ()

							pcCodigoLeido = cCodigoLeido
							pnNumeroOp = 1
							cDesc := EXTERNOS->ARTICULO
							// pcDescripcion = "EXT - " + cDesc
							pcDescripcion = cDesc
							pnPrecio = EXTERNOS->PRECIO
							pnCantidad = nCant
							pnPeso = 0.000
							pnSubTotal = pnPrecio * pnCantidad

							Ventas_button_ingresar_venta_action ()
							
						Else

							MsgStop ("Ese codigo no se encuentra ingresado en la Base de Datos...!" , "Base De Datos")
							Limpia_Gets ()
							Return Nil

						EndIf

		Case FLAG = 1														// Uno es que leyo un articulo Interno

			SetProperty ("Ventas" , "Button_Leer_Internos" , "Picture" , "Verde32")
			SetProperty ("Ventas" , "Button_Leer_Externos" , "Picture" , "Clear32")

			nPeso = 0.000
			cTipo := SubStr (cCodigoLeido,1,2)							 // Extrae los 2 primeros digitos
			cItem := SubStr (cCodigoLeido,3,4)							 // Extrae los 4 siguientes digitos (Articulo)
				cCodigoLeido3 := SubStr (cCodigoLeido,7,4)				 // Lee los pesos
				cCodigoLeido4 := SubStr (cCodigoLeido,11,2)				 // Lee los centavos
			nPrecioT = Val(AllTrim(cCodigoLeido3 + "." + cCodigoLeido4))  // Precio Char a Numerico con punto decimal

			DO Case
				Case cTipo = "20"										// Articulo Interno venta al peso 

					DbSelectArea ( "INTERNOS" )
					
						nItem = Val (cItem)
						DbSeek (nItem, .F.)
						
							If Found ()
							
								pnNumeroOp = 20
								pcCodigoLeido = cItem
								cDesc := INTERNOS->DESCRIPCIO
								// pcDescripcion = "VPP - " + cDesc
								pcDescripcion = cDesc
								pnPrecio := INTERNOS->PRECIO_L1
								pnPeso = nPrecioT / pnPrecio
								pnCantidad = 1
								pnSubTotal = nPrecioT
								SetProperty ("Ventas" , "Label_Cantidad" , "Value" , Str (pnCantidad))
					
								Ventas_button_ingresar_venta_action ()								

							EndIf
					
				Case cTipo = "21"										// Articulo Interno venta por unidad
					DbSelectArea ( "INTERNOS" )
					
						nItem = Val (cItem)
						DbSeek (nItem, .F.)
						
							If Found ()

								pnNumeroOp = 21
								pcCodigoLeido = cItem
								cDesc = INTERNOS->DESCRIPCIO
								// pcDescripcion = "VPU - " + cDesc
								pcDescripcion = cDesc
								pnPrecio := INTERNOS->PRECIO_L1
								pnCantidad = pnCantidad
								pnPeso = 0.000
								pnSubTotal = pnPrecio * pnCantidad
								
								Ventas_button_ingresar_venta_action ()
								
							EndIf
					
				Case cTipo = "22"										// Suma de articulos de un ticket ( TOTAL a cobrar )
					pnNumeroOp = 22
					pcCodigoLeido = cItem
					// pcDescripcion = "SDA - Suma De: " + AllTrim (SubStr (cItem,1,2)) + "  Articulos"
					pcDescripcion = "Suma De: " + AllTrim (SubStr (cItem,1,2)) + "  Articulos"
					pnPrecio = nPrecioT
					pnCantidad = 1
					pnPeso = 0.000
					pnSubTotal = nPrecioT
					SetProperty ("Ventas" , "Label_Cantidad" , "Value" , 1)

					Ventas_button_ingresar_venta_action ()
					
				// OtherWise
					// cDescri = ""
					
			EndCase
			
	EndCase
	
Return Nil
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Function Ventas_button_ingresar_venta_action

LOCAL nEnviada := 0

	If Empty (pcCodigoLeido)
		Limpia_Gets ()
		Return Nil
	EndIf

		DbSelectArea ( "RedConn" )

			Append Blank
				Replace Suc With pnSucursal , Op With pnNumeroOp , Codigo With pcCodigoLeido , Articulo With pcDescripcion
				Replace Precio With pnPrecio , Cantidad With pnCantidad , Peso With pnPeso
				Replace Subtotal With pnSubTotal , Fecha With Date () , E With nEnviada
					Commit
						DoMethod ("Ventas" , "Browse_TempVent" , "Refresh")
						Sum RedConn->Cantidad To nSuma1
						Sum RedConn->Peso To nSumaPeso
						Sum RedConn->Subtotal To nSuma2
						SetProperty ("Ventas" , "Label_Articulos" , "Value" , AllTrim (Str (nSuma1)))
						SetProperty ("Ventas" , "Label_Suma_Peso" , "Value" , AllTrim (Str (nSumaPeso)))
						SetProperty ("Ventas" , "Label_SubTotal" , "Value" , AllTrim (Str (nSuma2)))

		Limpia_Gets ()
	
Return Nil
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Function Ventas_button_cerrar_venta_action

	If LastRec () = 0

		MsgStop ("No hay Articulos ingresados en la operación !!!" + Chr (13) + Chr (10) ;
				+ "Imposible cerrar una venta vacia !!!" , "Atención")
		Return Nil
	
	EndIf

	Final_Cerrar_Venta ()
		
Return Nil
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Function Guardar_Venta (nEfectivo,nTarjeta,cTarjeta)

	DbSelectArea ( "RedConn" )
	
	Go Top
	
	DO While .NOT. EoF ()

		Replace TipoTarj With cTarjeta
		
		Skip
		
	EndDo

		Commit

	CloseDB ()
													// Primero guardo la venta localmente
	Use RedLink

		Append From REDCONN Fields Suc, Op, Codigo, Articulo, Precio, Cantidad, Peso, SubTotal, Fecha, E, TipoTarj

			Go Bottom

			Replace Cajero With pcUsuario, Efectivo With nEfectivo, Tarjeta With nTarjeta, Hora With Time ()

				Commit

	CloseDB ()
	
	OpenDB ()
	
		DbSelectArea ( "RedConn" )

			Zap

				DoMethod ("Ventas" , "Browse_TempVent" , "Refresh")	

//--------------------------------------------------// Aqui envio la venta al server  //------------------------

		If Enviar_Datos_Al_Server ()											// Si envió todo OK
		
			DoMethod (Ventas.StatusBar.Item (5) := "Server Status Connection: OK " )	
		Else
		
			DoMethod (Ventas.StatusBar.Item (5) := "Server Status Connection: Delayed " )	
			Limpia_Gets ()
			Return Nil
			
		EndIf
		
		Limpia_Gets ()
		
Return Nil
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Function Ventas_button_cancel_venta_action

	DbSelectArea ( "RedConn" )
		Zap
			DoMethod ("Ventas" , "Browse_TempVent" , "Refresh")	
			SetProperty ("Ventas" , "Label_Articulos" , "Value" , "0")
			SetProperty ("Ventas" , "Label_Suma_Peso" , "Value" , "0.000")
			SetProperty ("Ventas" , "Label_SubTotal" , "Value" , "0.00")
		
	Limpia_Gets ()

Return Nil
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Function Ventas_button_salir_de_ventas_action

	pcNumeroOp = 0
	pcCodigoLeido = ""
	pcDescripcion = ""
	pnPrecio = 0.00
	pnSubTotal = 0.00
	pnCantidad = 1
	pnPeso = 0.000

	Ventas. Release

Return Nil
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Function Ventas_browse_tempvent_ondblclick
															// Borra el registro seleccionado con doble click
															
	If MsgYesNo ("Realmente desea ELIMINAR el registro seleccionado ? " , "Atención !!!")
		Delete
		Pack
			DoMethod ("Ventas" , "Browse_TempVent" , "SetFocus")

			Sum RedConn->Cantidad TO nSuma1
			Sum RedConn->Peso TO nSumaPeso
			Sum RedConn->Subtotal TO nSuma2
			SetProperty ("Ventas" , "Label_Articulos" , "Value" , AllTrim (Str (nSuma1)))
			SetProperty ("Ventas" , "Label_Suma_Peso" , "Value" , AllTrim (Str (nSumaPeso)))
			SetProperty ("Ventas" , "Label_SubTotal" , "Value" , AllTrim (Str (nSuma2)))

			DoMethod ("Ventas" , "Browse_TempVent" , "Refresh")

		Go Top
		Limpia_Gets ()
	EndIf

Return Nil
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Function Limpia_Gets

	pcNumeroOp = 0								// Reseteo las variables para leer un nuevo articulo
	pcCodigoLeido = ""
	pcDescripcion = ""
	pnPrecio = 0.00
	pnSubTotal = 0.00
	pnCantidad = 1
	pnPeso = 0.000

	DoMethod (Ventas.StatusBar.Item (4) := "")
	SetProperty ("Ventas" , "Text_Codigo_Leido" , "Value" , "")
	SetProperty ("Ventas" , "Label_Cantidad" , "Value" , Str (pnCantidad))	
	DoMethod ("Ventas" , "Text_Codigo_Leido" , "SetFocus")

Return Nil
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Function OpenDB

	Bloquea_Botones_Main ()														// Bloqueo la ventana main

	USE EXTERNOS NEW
		INDEX ON BAR_CODE TO Icodigo
		
	USE INTERNOS NEW
		INDEX ON C_PLU TO Icodint

	USE RedConn NEW
		ZAP

	ON KEY F1 OF Ventas Action Ventas_button_cancel_venta_action ()
	ON KEY F9 OF Ventas Action Ventas_button_cerrar_venta_action ()
	
		SetProperty ("Ventas" , "Label_Cantidad" , "Value" , "1")
		SetProperty ("Ventas" , "Label_Articulos" , "Value" , "0")
		SetProperty ("Ventas" , "Label_Suma_Peso" , "Value" , "0.000")
		SetProperty ("Ventas" , "Label_SubTotal" , "Value" , "0.00")

Return Nil
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Function CloseDB

	Desbloquea_Botones_Main ()													// Desbloqueo la ventana main

	DbCloseAll ()

Return Nil
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////